// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'MySQLBackUp.pas' rev: 5.00

#ifndef MySQLBackUpHPP
#define MySQLBackUpHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <ComCtrls.hpp>	// Pascal unit
#include <MyBackUpDll.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Mysqlbackup
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 1)
struct TServerInfo
{
	System::SmallString<40>  Host;
	System::SmallString<40>  User;
	System::SmallString<40>  Database;
} ;
#pragma pack(pop)

struct TMyErrRec
{
	System::SmallString<255>  MyErrStr;
	int MyErrNo;
} ;

struct TMyDumpRec
{
	System::SmallString<100>  Table;
	System::SmallString<100>  Database;
	int Records;
} ;

typedef void __fastcall (__closure *TSvInfo)(System::TObject* Sender, const TServerInfo &data);

typedef void __fastcall (__closure *TMyDataError)(System::TObject* Sender, const TMyErrRec &ErrInfo)
	;

typedef void __fastcall (__closure *TCompError)(System::TObject* Sender, AnsiString PrgError);

typedef void __fastcall (__closure *TMyDumpInfo)(System::TObject* Sender, const TMyDumpRec &DumpInfo
	);

class DELPHICLASS TMySQLBackUp;
class PASCALIMPLEMENTATION TMySQLBackUp : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	#pragma pack(push, 1)
	TServerInfo FSvInfo;
	#pragma pack(pop)
	
	TSvInfo FOnSvInfo;
	TMyErrRec FMyErrRec;
	TMyDataError FOnMyDataError;
	TCompError FOnCompError;
	TMyDumpRec FMyDumpRec;
	TMyDumpInfo FOnAfterDump;
	Classes::TStrings* FSQL;
	Classes::TStrings* FDatabases;
	Classes::TStrings* FTables;
	AnsiString FDatabase;
	AnsiString FHost;
	int FPort;
	AnsiString FUser;
	AnsiString FPassword;
	AnsiString FBackFileName;
	AnsiString FRestoreFileName;
	AnsiString FLogFileName;
	AnsiString FDumpVersion;
	bool FInitDLL;
	bool FIsDLL;
	bool FConnected;
	bool FLockOpt;
	bool FtOpt;
	bool FcOpt;
	bool FwhereOpt;
	bool FExtInsOpt;
	bool FdropOpt;
	bool FmultiOpt;
	bool FWriteLogHeading;
	AnsiString FSqlWhere;
	bool FLogFileOpt;
	AnsiString FServerInfo;
	AnsiString FHostInfo;
	int FBackUpRecords;
	Extctrls::TTimer* FTimer;
	unsigned FRefreshTime;
	Comctrls::TProgressBar* FProgressBar;
	int FProgressStep;
	Classes::TNotifyEvent FOnDisconnect;
	
protected:
	void __fastcall SetSQL(const Classes::TStrings* Value);
	void __fastcall CreateError(const AnsiString ErrStr);
	
public:
	__fastcall virtual TMySQLBackUp(Classes::TComponent* AOwner);
	__fastcall virtual ~TMySQLBackUp(void);
	void __fastcall DoOpen(void);
	void __fastcall DoClose(void);
	void __fastcall Connect(void);
	int __fastcall DoQuery(void);
	bool __fastcall IsTheServerAlive(void);
	bool __fastcall MakeBackUp(AnsiString TableName);
	int __fastcall RestoreSQLFile(void);
	int __fastcall GetDatabases(void);
	int __fastcall GetTables(AnsiString Database);
	int __fastcall GetTableStructure(AnsiString TableName);
	int __fastcall ReadRecords(void);
	
__published:
	__property AnsiString DumpVersion = {read=FDumpVersion};
	__property Classes::TStrings* Databases = {read=FDatabases};
	__property Classes::TStrings* Tables = {read=FTables};
	__property Classes::TStrings* SQL = {read=FSQL, write=SetSQL};
	__property AnsiString Database = {read=FDatabase, write=FDatabase};
	__property AnsiString BackFileName = {read=FBackFileName, write=FBackFileName};
	__property AnsiString RestoreFileName = {read=FRestoreFileName, write=FRestoreFileName};
	__property AnsiString LogFileName = {read=FLogFileName, write=FLogFileName};
	__property AnsiString Host = {read=FHost, write=FHost};
	__property int Port = {read=FPort, write=FPort, nodefault};
	__property AnsiString User = {read=FUser, write=FUser};
	__property AnsiString Password = {read=FPassword, write=FPassword};
	__property bool Connected = {read=FConnected, nodefault};
	__property int BackUpRecords = {read=ReadRecords, nodefault};
	__property bool LockOpt = {read=FLockOpt, write=FLockOpt, nodefault};
	__property bool DropOpt = {read=FdropOpt, write=FdropOpt, nodefault};
	__property bool tOption = {read=FtOpt, write=FtOpt, nodefault};
	__property bool cOption = {read=FcOpt, write=FcOpt, nodefault};
	__property bool ExtInsOpt = {read=FExtInsOpt, write=FExtInsOpt, nodefault};
	__property bool MultiTbOpt = {read=FmultiOpt, write=FmultiOpt, nodefault};
	__property bool LogFileOpt = {read=FLogFileOpt, write=FLogFileOpt, nodefault};
	__property bool WriteLogHeading = {read=FWriteLogHeading, write=FWriteLogHeading, nodefault};
	__property bool WhereOpt = {read=FwhereOpt, write=FwhereOpt, nodefault};
	__property AnsiString SqlWhere = {read=FSqlWhere, write=FSqlWhere};
	__property Comctrls::TProgressBar* ProgressBar = {read=FProgressBar, write=FProgressBar};
	__property int ProgressStep = {read=FProgressStep, write=FProgressStep, nodefault};
	__property TSvInfo OnServerConnect = {read=FOnSvInfo, write=FOnSvInfo};
	__property TMyDataError OnMyDataError = {read=FOnMyDataError, write=FOnMyDataError};
	__property TMyDumpInfo OnAfterDump = {read=FOnAfterDump, write=FOnAfterDump};
	__property Classes::TNotifyEvent OnDisconnect = {read=FOnDisconnect, write=FOnDisconnect};
	__property TCompError OnActionError = {read=FOnCompError, write=FOnCompError};
};


//-- var, const, procedure ---------------------------------------------------
#define MSDVersion "1.0"
extern PACKAGE void __fastcall Register(void);

}	/* namespace Mysqlbackup */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Mysqlbackup;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// MySQLBackUp
